<%@ page import="org.jahia.modules.remotepublish.webflow.NodeSelection" %>
<%@ page import="org.jahia.modules.remotepublish.CheckCompareJobAction" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>

<template:addResources type="javascript"
                       resources="jquery.min.js,jquery-ui.min.js,admin-bootstrap.js,jquery.tablesorter.js,jquery.blockUI.js,workInProgress.js,bootbox.min.js"/>
<c:set var="uiLang" value="${renderContext.UILocale.language}"/>
<c:set var="jqCronLang" value="${'de' == uiLang || 'fr' == uiLang ? uiLang : 'en'}"/>
<template:addResources type="css" resources="admin-bootstrap.css"/>
<template:addResources type="css" resources="jquery-ui.smoothness.css,jquery-ui.smoothness-jahia.css"/>


<fmt:message var="i18nWaiting" key="label.workInProgressTitle"/><c:set var="i18nWaitingJs"
                                                                       value="${functions:escapeJavaScript(i18nWaiting)}"/>
<fmt:message var="i18nExecute" key="label.executeRemotePublication"/><c:set var="i18nExecuteJs"
                                                                            value="${functions:escapeJavaScript(i18nExecute)}"/>
<fmt:message var="i18nExecuteConfirm" key="label.remotepublish.execute.confirm"/>
<fmt:message var="i18nEdit" key="label.edit"/>
<fmt:message var="i18nDelete" key="label.delete"/><c:set var="i18nDeleteJs" value="${functions:escapeJavaScript(i18nDelete)}"/>
<fmt:message var="i18nDeleteConfirm" key="label.remotepublish.delete.confirm"/>
<fmt:message var="i18nCancel" key="label.cancel"/><c:set var="i18nCancelJs" value="${functions:escapeJavaScript(i18nCancel)}"/>
<fmt:message var="i18nOk" key="label.ok"/><c:set var="i18nOk" value="${functions:escapeJavaScript(i18nOk)}"/>

<fmt:message var="i18nConfirmation" key="label.remotepublish.recreate.confirmation"/><c:set var="i18nConfirmation" value="${functions:escapeJavaScript(i18nConfirmation)}"/>
<fmt:message var="i18nRecreateConfirmationMessage" key="label.remotepublish.recreate.confirmationMessage"/><c:set var="i18nRecreateConfirmationMessage" value="${functions:escapeJavaScript(i18nRecreateConfirmationMessage)}"/>
<fmt:message var="i18nRecreate" key="label.remotepublish.recreate"/><c:set var="i18nRecreate" value="${functions:escapeJavaScript(i18nRecreate)}"/>

<fmt:message var="i18nCompareFullSite" key="label.remotepublish.compare.confirm.fullSite"/><c:set var="i18nCompareFullSite" value="${functions:escapeJavaScript(i18nCompareFullSite)}"/>
<fmt:message var="i18nCompareSubTree" key="label.remotepublish.compare.confirm.subTree"/><c:set var="i18nCompareSubTree" value="${functions:escapeJavaScript(i18nCompareSubTree)}"/>
<fmt:message var="i18nCompareAlreadyPlanned" key="label.remotepublish.compare.confirm.jobRunning"/><c:set var="i18nCompareAlreadyPlanned" value="${functions:escapeJavaScript(i18nCompareAlreadyPlanned)}"/>

<template:addResources type="inlinejavascript">
    <script type="text/javascript">

        var submitOk = false;

        $(document).ready(function () {
            $("#recreate").submit(function () {
                if (!submitOk) {
                    $('#rpConfirmExecuteRecreateButton').click();
                    return false;
                }
            });
            $("#compare").submit(function () {
                if (!submitOk) {
                    $('#rpConfirmExecuteCompareButton').click();
                    return false;
                }
            });
            $("#path").keypress(function () {
                $('#subtreeRadio').click();
            });
        });

        String.prototype.format = function () {
            var args = arguments;

            return this.replace(/\{(\d+)\}/g, function () {
                return args[arguments[1]];
            });
        };

        function rpSubmitForm(form) {
            submitOk = true;
            $('#' + form).submit();
        }

        function rpConfirmExecute(form, title, message, buttonlabel, shouldCheckCompareJob) {
            bootbox.confirm({
                title: title,
                message: message,
                buttons: {
                    cancel: {
                        label: '${i18nCancelJs}'
                    },
                    confirm: {
                        label: buttonlabel,
                        className: 'btn-warning btn-primary'
                    }
                },
                callback: function (result) {
                    if (result) {
                        if (shouldCheckCompareJob) {
                            checkCompareJob(form);
                        } else {
                            workInProgress('${i18nWaitingJs}');
                            rpSubmitForm(form);
                        }
                    }
                }
            });
        }

        function checkCompareJob(form) {
            $.post("<c:url value="${url.base}${renderContext.mainResource.node.path}.checkCompareJob.do"/>", null, function(data) {
                if (data['<%= CheckCompareJobAction.COMPARE_JOB_RUNNING %>']) {
                    rpConfirmExecute('compare', '${i18nConfirmation}', '${i18nCompareAlreadyPlanned}', '${i18nOk}');
                } else {
                    workInProgress('${i18nWaitingJs}');
                    rpSubmitForm(form);
                }
            }, "json");
        }

        function rpConfirmExecuteComparison () {
            if($('input[name="comparisonScope"]:checked').val() == "subTree") {
                rpConfirmExecute('compare', '${i18nConfirmation}', '${i18nCompareSubTree}'.format($('#compare input[name="path"]').val()), '${i18nOk}', true);
            } else {
                rpConfirmExecute('compare', '${i18nConfirmation}', '${i18nCompareFullSite}', '${i18nOk}', true);
            }
        }

        function rpConfirmExecuteRecreate () {
            rpConfirmExecute('recreate', '${i18nConfirmation}', '${i18nRecreateConfirmationMessage}'.format($('#recreate input[name = "path"]').val()), '${i18nRecreate}');
        }

    </script>
</template:addResources>

<h2><fmt:message key="label.remotepublish.advance.tools"><fmt:param value="${remotePublication.name}"/></fmt:message></h2>

<div>
    <form action="${flowExecutionUrl}" method="post" style="display: inline;" id="rpForm">
        <input type="hidden" name="_eventId" value="cancel" />
        <button class="btn" type="submit">
            <i class="icon-backward"></i>
            &nbsp;<fmt:message key='label.remotepublish.back'/>
        </button>
    </form>
</div>

<div>
    <c:if test="${not empty flowRequestContext.messageContext.allMessages}">
        <div>
            <c:forEach items="${flowRequestContext.messageContext.allMessages}" var="message">
                <c:if test="${message.severity eq 'INFO'}">
                    <div class="alert alert-success">
                        <button type="button" class="close" data-dismiss="alert">&times;</button>
                            ${fn:escapeXml(message.text)}
                    </div>
                </c:if>
                <c:if test="${message.severity eq 'ERROR'}">
                    <div class="alert alert-error">
                        <button type="button" class="close" data-dismiss="alert">&times;</button>
                            ${fn:escapeXml(message.text)}
                    </div>
                </c:if>
            </c:forEach>
        </div>
    </c:if>
    <div class="box-1">
        <form action="${flowExecutionUrl}" method="post" id="compare">
            <input type="hidden" name="_eventId" value="compare"/>
            <input type="hidden" id="rpId" name="rpId" value="${remotePublication.id}"/>
            <fieldset>
                <legend><fmt:message key="label.remotepublish.advance.compare"/></legend>
                <p><fmt:message key="label.remotepublish.advance.compare.desc"/></p>
                <br>
                <div class="container-fluid">
                    <div class="row-fluid">
                        <div class="span4">
                            <p><fmt:message key="label.remotepublish.advance.compare.chose"/></p>
                            <label class="radio">
                                <form:radiobutton path="nodeSelection.comparisonScope" value="<%= NodeSelection.COMPARISON_SCOPE_FULL_SITE %>"/>
                                &nbsp;<fmt:message key="label.remotepublish.advance.compare.full"/>
                            </label>
                            <label class="radio">
                                <form:radiobutton id="subtreeRadio" path="nodeSelection.comparisonScope" value="<%= NodeSelection.COMPARISON_SCOPE_SUB_TREE %>"/>
                                &nbsp;<fmt:message key="label.remotepublish.advance.compare.path"/>
                            </label>
                            <form:input type="text" path="nodeSelection.path" class="span12" id="path"/>
                        </div>
                    </div>

                    <div class="row-fluid">
                        <div class="span12">
                            <button class="btn btn-primary" type="button" id="rpConfirmExecuteCompareButton"
                                    onclick="rpConfirmExecuteComparison(); return false;" >
                                <i class="icon-refresh icon-white"></i>
                                &nbsp;<fmt:message key="label.ok"/>
                            </button>
                        </div>
                    </div>
                </div>
            </fieldset>
        </form>
    </div>

    <div class="box-1">
        <form action="${flowExecutionUrl}" method="post" id="recreate">
            <input type="hidden" name="_eventId" value="recreate"/>
            <input type="hidden" name="rpId" value="${remotePublication.id}"/>
            <fieldset>
                <legend><fmt:message key="label.remotepublish.forceRemote"/></legend>
                <p><fmt:message key="label.remotepublish.advance.force.desc"/></p>
                <br>
                <div class="container-fluid">
                    <div class="row-fluid">
                        <div class="span4">
                            <label for="path"><fmt:message key="label.remotepublish.path"/></label>
                            <form:input type="text" path="nodeSelection.path" class="span12" id="path"/>
                        </div>
                    </div>
                    <div class="row-fluid">
                        <div class="span4">
                            <label for="saveAndRestoreUGC">
                                <form:checkbox path="nodeSelection.saveAndRestoreUGC" id="saveAndRestoreUGC"/>
                                &nbsp;<fmt:message key="label.remotepublish.saveAndRestoreUGC"/>
                            </label>
                        </div>
                    </div>
                    <div class="row-fluid">
                        <div class="span4">
                            <label for="includeSubPages">
                                <form:checkbox path="nodeSelection.includeSubPages" id="includeSubPages"/>
                                &nbsp;<fmt:message key="label.remotepublish.includeSubPages"/>
                            </label>
                        </div>
                    </div>
                    <div class="row-fluid">
                        <div class="span12">
                            <button class="btn btn-primary" type="button" id="rpConfirmExecuteRecreateButton"
                                    onclick="rpConfirmExecuteRecreate(); return false;">
                                <i class="icon-repeat icon-white"></i>
                                &nbsp;<fmt:message key="label.remotepublish.recreate"/>
                            </button>
                        </div>
                    </div>
                </div>
            </fieldset>
        </form>
    </div>
</div>
