<%@ page import="org.jahia.modules.remotepublish.RemotePublishUtils" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>

<template:addResources type="javascript"
                       resources="jquery.min.js,jquery-ui.min.js,admin-bootstrap.js,jquery.tablesorter.js,jquery.blockUI.js,workInProgress.js,bootbox.min.js"/>
<template:addResources type="css" resources="admin-bootstrap.css"/>
<template:addResources type="css" resources="jquery-ui.smoothness.css,jquery-ui.smoothness-jahia.css,tablecloth.css"/>
<template:addResources type="javascript" resources="datatables/jquery.dataTables.js,i18n/jquery.dataTables-${currentResource.locale}.js,datatables/dataTables.bootstrap-ext.js"/>
<template:addResources type="css" resources="datatables/css/bootstrap-theme.css,tablecloth.css"/>

<c:set value="<%= RemotePublishUtils.PERM_REMOTE_PUBLICATION_ADMIN_ACTIONS%>" var="PERM_REMOTE_PUBLICATION_ADMIN_ACTIONS"/>
<c:set value="${jcr:hasPermission(renderContext.mainResource.node, PERM_REMOTE_PUBLICATION_ADMIN_ACTIONS)}" var="hasRemotePublicationAdminPermission"/>

<fmt:message var="i18nDetails" key="label.remotepublish.history.details"/>

<h2><fmt:message key="label.remotepublish.title"/>&nbsp;<fmt:message key="label.remotepublish.compare.result.title"/></h2>

    <fmt:message var="i18nWaiting" key="label.workInProgressTitle"/><c:set var="i18nWaitingJs" value="${functions:escapeJavaScript(i18nWaiting)}"/>
    <fmt:message var="i18nCancel" key="label.cancel"/><c:set var="i18nCancelJs" value="${functions:escapeJavaScript(i18nCancel)}"/>
    <fmt:message var="i18nOk" key="label.ok"/><c:set var="i18nOk" value="${functions:escapeJavaScript(i18nOk)}"/>
    <fmt:message var="i18nAll" key="label.all"/><c:set var="i18nAll" value="${functions:escapeJavaScript(i18nAll)}"/>
    <fmt:message var="i18nForceRP" key="label.remotepublish.compare.result.force.remotepublication"/><c:set var="i18nForceRPJavaScript" value="${functions:escapeJavaScript(i18nForceRP)}"/>
    <fmt:message var="i18nForceRPMessage" key="label.remotepublish.compare.result.force.remotepublication.message"/><c:set var="i18nForceRPMessage" value="${functions:escapeJavaScript(i18nForceRPMessage)}"/>

    <template:addResources type="inlinejavascript">
        <script type="text/javascript">
            $(document).ready(function () {
                $('#compareResultTable').dataTable({
                    "iDisplayLength": 25,
                    "aLengthMenu": [[25, 50, 100, -1], [25, 50, 100, "${i18nAll}"]],
                    "sPaginationType": "bootstrap",
                    "aaSorting": [], //this option disable sort by default, the user steal can use column names to sort the table
                    "bStateSave": true
                });
            });

            var selectedIdentifiers = [];

            function rpSubmitForm(act) {
                $('#rpAction').val(act);
                $("#selectedIdentifiers").val(selectedIdentifiers);
                $('#rpForm').submit();
            }

            function rpConfirmExecute(act, label, message) {
                bootbox.confirm({
                    title: label,
                    message: message,
                    buttons: {
                        cancel: {
                            label: '${i18nCancelJs}'
                        },
                        confirm: {
                            label: '${i18nOk}',
                            className: 'btn-warning btn-primary'
                        }
                    },
                    callback: function (result) {
                        if (result) {
                            workInProgress('${i18nWaitingJs}');
                            rpSubmitForm(act);
                        }
                    }
                });
            }

            function selectIdentifiers(input) {
                var $input = $(input);

                var path = $input.attr('value');
                if ($input.is(':checked')) {
                    selectedIdentifiers[selectedIdentifiers.length] = path
                } else {
                    if (selectedIdentifiers.indexOf(path) > -1) {
                        selectedIdentifiers.splice(selectedIdentifiers.indexOf(path),1)
                    }
                }

                if (selectedIdentifiers.length == 0) {
                    $('#saveButton').attr('disabled', 'disabled')
                } else {
                    $('#saveButton').removeAttr("disabled")
                }
            }

            $(document).ready(function() {
                $('#cbSelectedAllPaths').click(function() {
                    var state=this.checked;
                    $.each($(':checkbox[name="selectedIdentifiers"]'), function() {
                        if (this.checked != state) {
                            this.checked = state;
                            $(this).change()
                        }
                    });
                });
            })
        </script>
    </template:addResources>

    <p>
        <fmt:message key="label.remotepublish.compare.result.executed.time">
            <fmt:param value="${execution.dateFormatted}"/>
        </fmt:message>
    </p>

    <p><fmt:message key="label.remotepublish.compare.result.message"/></p>

    <div>
        <form action="${flowExecutionUrl}" method="post" style="display: inline;" id="rpForm">
            <input type="hidden" id="rpAction" name="_eventId" value=""/>
            <input type="hidden" id="rpId" name="rpId" value="${remotePublication.id}"/>
            <input id="selectedIdentifiers" type="hidden" name="selectedIdentifiers"/>
            <button class="btn" type="submit" name="mybutton" onclick="rpSubmitForm('history'); return false;">
                <i class="icon-arrow-left"></i>
                &nbsp;<fmt:message key="label.remotepublish.compare.result.back"/>
            </button>

            <c:if test="${hasRemotePublicationAdminPermission}">
                <button class="btn btn-primary" type="submit" id="saveButton" disabled="disabled" onclick="rpConfirmExecute('forceRP', '${i18nForceRPJavaScript}', '${i18nForceRPMessage}'); return false;">
                    <i class="icon-ok icon-white"></i>
                    &nbsp;${i18nForceRP}
                </button>
            </c:if>
        </form>
    </div>
    <c:if test="${not empty flowRequestContext.messageContext.allMessages}">
        <div>
            <c:forEach items="${flowRequestContext.messageContext.allMessages}" var="message">
                <c:if test="${message.severity eq 'INFO'}">
                    <div class="alert alert-success">
                        <button type="button" class="close" data-dismiss="alert">&times;</button>
                            ${fn:escapeXml(message.text)}
                    </div>
                </c:if>
                <c:if test="${message.severity eq 'ERROR'}">
                    <div class="alert alert-error">
                        <button type="button" class="close" data-dismiss="alert">&times;</button>
                            ${fn:escapeXml(message.text)}
                    </div>
                </c:if>
            </c:forEach>
        </div>
    </c:if>

    <table cellpadding="0" cellspacing="0" border="0" class="table table-striped table-bordered" id="compareResultTable">
        <thead>
        <tr>
            <c:if test="${hasRemotePublicationAdminPermission}">
                <th><input type="checkbox" name="selectedAllPaths" id="cbSelectedAllPaths"/></th>
            </c:if>
            <th><fmt:message key="label.remotepublish.compare.result.table.header.type"/></th>
            <th><fmt:message key="label.remotepublish.compare.result.table.header.path"/></th>
            <th><fmt:message key="label.remotepublish.compare.result.table.header.id"/></th>
        </tr>
        </thead>
        <tbody>
        <c:forEach items="${execution.response['compare']}" var="compareEntry" varStatus="status">
            <tr class="${status.index % 2 == 0 ? 'evenLine' : 'oddLine'}">
                <c:if test="${hasRemotePublicationAdminPermission}">
                    <td><input onchange="selectIdentifiers(this)" class="selectedPath" type="checkbox" name="selectedIdentifiers" value="${compareEntry.compareSourceId}"/></td>
                </c:if>
                <td><fmt:message key="label.remotepublish.compare.result.table.header.type.${compareEntry.compareType}"/></td>
                <td>${compareEntry.compareRemotePath}</td>
                <td>${compareEntry.compareSourceId}</td>
            </tr>
        </c:forEach>
        </tbody>
    </table>

