<%@ page import="org.jahia.modules.remotepublish.RemotePublicationService" %>
<%@ page import="org.jahia.modules.remotepublish.RemotePublishUtils" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>

<c:set var="subTreeCompareOperationType" value="<%= RemotePublicationService.NODE_RESULT_OPERATION_TYPE_SUB_TREE_COMPARE %>"/>
<c:set var="fullSitecompareOperationType" value="<%= RemotePublicationService.NODE_RESULT_OPERATION_TYPE_FULL_SITE_COMPARE %>"/>
<c:set var="executeOperationType" value="<%= RemotePublicationService.NODE_RESULT_OPERATION_TYPE_EXECUTE %>"/>

<template:addResources type="javascript" resources="jquery.min.js,jquery-ui.min.js,admin-bootstrap.js,jquery.tablesorter.js,jquery.blockUI.js,workInProgress.js,bootbox.min.js"/>
<template:addResources type="css" resources="admin-bootstrap.css"/>
<template:addResources type="css" resources="jquery-ui.smoothness.css,jquery-ui.smoothness-jahia.css,tablecloth.css"/>

<c:set value="<%= RemotePublishUtils.PERM_REMOTE_PUBLICATION_ADMIN_ACTIONS%>" var="PERM_REMOTE_PUBLICATION_ADMIN_ACTIONS"/>
<c:set value="${jcr:hasPermission(renderContext.mainResource.node, PERM_REMOTE_PUBLICATION_ADMIN_ACTIONS)}" var="hasRemotePublicationAdminPermission"/>

<fmt:message var="i18nDetails" key="label.remotepublish.history.details"/>

<h2><fmt:message key="label.remotepublish.title"/></h2>

    <c:set var="executionsNotEmpty" value="${fn:length(remotePublication.executions) > 0}"/>

    <fmt:message var="i18nCancel" key="label.cancel"/><c:set var="i18nCancelJs" value="${functions:escapeJavaScript(i18nCancel)}"/>
    <fmt:message var="i18nClearHistory" key="label.remotepublish.clearHistory"/>
    <fmt:message var="i18nCompareResult" key="label.remotepublish.compareResult"/>

    <template:addResources type="inlinejavascript">
        <script type="text/javascript">
            function rpSubmitForm(act, rpExecId) {
                $('#rpAction').val(act);
                $('#rpExecId').val(rpExecId);
                $('#rpForm').submit();
            }
            $(document).ready(function() {
                $('.typeradio').change(function () {
                    if ($('input:radio[name=type]:checked').val() == "range") {
                        $(".range-control").show();
                    } else {
                        $(".range-control").hide();
                    }
                });

                $( function() {
                    $(".datepicker").datepicker();
                } );
            });
        </script>
    </template:addResources>

    <div>
        <div>
            <form class="form-horizontal" action="${flowExecutionUrl}" method="post" style="display: inline;" id="rpForm">
                <input type="hidden" name="rpExecId" id="rpExecId" />
                <input type="hidden" name="rpId" id="rpId" value="${remotePublication.id}"/>
                <input type="hidden" name="rpPageSize" id="rpPageSize" value="${remotePublication.executionsPageSize}"/>
                <input type="hidden" name="rpPage" id="rpPage" />
                <input type="hidden" id="rpAction" name="_eventId" value="" />
                <button class="btn" type="submit" name="mybutton" onclick="rpSubmitForm('overview', ''); return false;">
                    <i class="icon-arrow-left"></i>
                    &nbsp;<fmt:message key="label.remotepublish.back"/>
                </button>

                <c:if test="${executionsNotEmpty && hasRemotePublicationAdminPermission}">
                    <c:forEach items="${remotePublication.executions}" var="execution" begin="0" end="0">
                        <fmt:formatDate value="${execution.date}" var="maxDate" pattern="MM/dd/yyyy"  />
                    </c:forEach>
                    <c:forEach items="${remotePublication.executions}" var="execution" begin="${fn:length(remotePublication.executions)-1}" end="${fn:length(remotePublication.executions)-1}">
                        <fmt:formatDate value="${execution.date}" var="minDate" pattern="MM/dd/yyyy"  />
                    </c:forEach>

                    <button class="btn"  type="button" data-toggle="modal" data-target="#clearHistoryModal">
                        <i class="icon-remove"></i>
                        &nbsp;${i18nClearHistory}
                    </button>


                    <div id="clearHistoryModal" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="clearHistoryLabel" aria-hidden="true">
                        <div class="modal-header">
                            <button type="button" class="bootbox-close-button close" data-dismiss="modal" aria-hidden="true">&times;</button>
                            <h3 id="clearHistoryLabel">${i18nClearHistory}</h3>
                        </div>
                        <div class="modal-body">
                            <div class="control-group">
                                <label class="radio">
                                    <input type="radio" name="type" class="typeradio" id="typeAll" value="all" checked="checked"/> <fmt:message key="label.remotepublish.clearHistory.all"/>
                                </label>
                                <label class="radio">
                                    <input type="radio" name="type" class="typeradio" id="typeRange" value="range"/> <fmt:message key="label.remotepublish.clearHistory.range"/>
                                </label>
                            </div>
                            <div class="control-group range-control" style="display: none">
                                <label class="control-label" for="fromDay"> <fmt:message key="label.remotepublish.clearHistory.from"/> : </label>
                                <input type="text" name="from" class="datepicker" value="${minDate}">
                            </div>
                            <div class="control-group range-control" style="display: none">
                                <label class="control-label" for="toDay"><fmt:message key="label.remotepublish.clearHistory.to"/> : </label>
                                <input type="text" name="to" class="datepicker"  value="${maxDate}">
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button class="btn" data-dismiss="modal" aria-hidden="true">${i18nCancel}</button>
                            <button class="btn btn-primary" onclick="rpSubmitForm('clearHistory', '')">${i18nClearHistory}</button>
                        </div>
                    </div>
                </c:if>

                <button class="btn" type="submit" name="mybutton" onclick="rpSubmitForm('refresh', ''); return false;">
                    <i class="icon-refresh"></i>
                    &nbsp;<fmt:message key="label.refresh"/>
                </button>
            </form>
        </div>
        <c:if test="${not empty flowRequestContext.messageContext.allMessages}">
            <div>
                <c:forEach items="${flowRequestContext.messageContext.allMessages}" var="message">
                    <c:if test="${message.severity eq 'INFO'}">
                        <div class="alert alert-success">
                            <button type="button" class="close" data-dismiss="alert">&times;</button>
                                ${fn:escapeXml(message.text)}
                        </div>
                    </c:if>
                    <c:if test="${message.severity eq 'ERROR'}">
                        <div class="alert alert-error">
                            <button type="button" class="close" data-dismiss="alert">&times;</button>
                                ${fn:escapeXml(message.text)}
                        </div>
                    </c:if>
                </c:forEach>
            </div>
        </c:if>
        <div>
            <table class="table table-bordered table-striped table-hover" id="tableRemotePublications">
                <thead>
                <tr>
                    <th>
                        <fmt:message key="label.remotepublish.history.date"/>
                    </th>
                    <th>
                        <fmt:message key="label.remotepublish.history.type"/>
                    </th>
                    <th>
                        <fmt:message key="label.remotepublish.history.author"/>
                    </th>
                    <th>
                        <fmt:message key="label.remotepublish.history.status"/>
                    </th>
                    <th>
                        <fmt:message key="label.remotepublish.history.details"/>
                    </th>
                </tr>
                </thead>
                <tbody>
                <c:choose>
                    <c:when test="${fn:length(remotePublication.executions) > 0}">
                        <c:forEach items="${remotePublication.executions}" var="execution" varStatus="status">
                            <tr>
                                <td>
                                        ${execution.dateFormatted}
                                </td>
                                <td>
                                    <fmt:message key="label.remotepublish.history.${execution.operationType}"/>
                                </td>
                                <td>
                                    <c:if test="${execution.scheduled}">
                                        <fmt:message key="label.remotepublish.scheduled"/>
                                    </c:if>
                                    <c:if test="${not execution.scheduled}">
                                        ${execution.user}
                                    </c:if>
                                </td>
                                <td>
                                    <c:if test="${execution.status eq 'failure'}">
                                        <span class="badge badge-important"><fmt:message key="label.remotepublish.failure"/></span>
                                    </c:if>
                                    <c:if test="${execution.status eq 'success'}">
                                        <span class="badge badge-success"><fmt:message key="label.remotepublish.success"/></span>
                                    </c:if>
                                </td>
                                <td>
                                    <c:if test="${execution.status eq 'failure'}">
                                        <fmt:message key="label.remotepublish.error.${execution.response['error']}" >
                                            <fmt:param value="${execution.response['details']}"/>
                                        </fmt:message>
                                        <c:if test="${execution.response['error'] eq 'INVALID_MODULES'}">
                                            <a style="margin-bottom:0;" class="btn btn-small" title="${fn:escapeXml(i18nDetails)}" href="#detail" onclick="rpSubmitForm('detail', ${status.index}); return false;">
                                                <i class="icon-info-sign"></i>
                                            </a>
                                        </c:if>
                                    </c:if>
                                    <c:choose>
                                        <c:when test="${execution.operationType eq executeOperationType}">
                                            <c:if test="${not empty execution.response['logEntriesCount']}">
                                                <fmt:message key="label.remotepublish.processed" >
                                                    <fmt:param value="${execution.response['logEntriesCount']}"/>
                                                </fmt:message>
                                                <c:if test="${not empty execution.response['compare']}">
                                                    </br>
                                                    <fmt:message key="label.remotepublish.history.inconsistenciesAfterExecution">
                                                        <fmt:param value="${fn:length(execution.response['compare'])}"/>
                                                    </fmt:message>
                                                    <a style="margin-bottom:0;" class="btn btn-small" title="${fn:escapeXml(i18nDetails)}" href="#compareResult" onclick="rpSubmitForm('compareResult', ${status.index}); return false;">
                                                        <i class="icon-info-sign"></i>
                                                    </a>
                                                </c:if>
                                            </c:if>
                                        </c:when>
                                        <c:when test="${execution.operationType eq fullSitecompareOperationType || execution.operationType eq subTreeCompareOperationType}">
                                            <c:if test="${empty execution.response['compare']}">
                                                <fmt:message key="label.remotepublish.history.noInconsistencies"/>
                                            </c:if>
                                            <c:if test="${not empty execution.response['compare']}">
                                                <fmt:message key="label.remotepublish.history.inconsistencies">
                                                    <fmt:param value="${fn:length(execution.response['compare'])}"/>
                                                </fmt:message>
                                                <a style="margin-bottom:0;" class="btn btn-small" title="${fn:escapeXml(i18nDetails)}" href="#compareResult" onclick="rpSubmitForm('compareResult', ${status.index}); return false;">
                                                    <i class="icon-info-sign"></i>
                                                </a>
                                            </c:if>
                                        </c:when>
                                    </c:choose>
                                </td>
                            </tr>
                        </c:forEach>
                    </c:when>
                    <c:otherwise>
                        <tr>
                            <td colspan="5"><fmt:message key="label.noItemFound"/></td>
                        </tr>
                    </c:otherwise>
                </c:choose>
                </tbody>
            </table>


            <c:if test="${remotePublication.executionsCount > remotePublication.executionsPageSize}">
                <c:if test="${remotePublication.executionsPage > 0}">
                    <a href="#" onclick="$('#rpPage').val(${remotePublication.executionsPage - 1});rpSubmitForm('changePage', ''); return false;"><fmt:message key="label.remotepublish.history.previous"/></a>
                </c:if>

                <c:forEach begin="0" end="${(remotePublication.executionsCount - 1) / remotePublication.executionsPageSize}" varStatus="loop">

                    <c:choose>
                        <c:when test="${loop.index == remotePublication.executionsPage}">
                            <strong>${loop.index + 1}</strong>
                        </c:when>

                        <c:when test="${loop.first}">
                            <a href="#" onclick="$('#rpPage').val(${loop.index});rpSubmitForm('changePage', ''); return false;">${loop.index + 1}</a>
                        </c:when>

                        <c:when test="${loop.last}">
                            <a href="#" onclick="$('#rpPage').val(${loop.index});rpSubmitForm('changePage', ''); return false;">${loop.index + 1}</a>
                        </c:when>

                        <c:when test="${loop.index - remotePublication.executionsPage == 5 or remotePublication.executionsPage - loop.index == 5}">
                            ...
                        </c:when>
                        <c:when test="${loop.index - remotePublication.executionsPage > 5 or remotePublication.executionsPage - loop.index > 5}">
                        </c:when>

                        <c:otherwise>
                            <a href="#" onclick="$('#rpPage').val(${loop.index});rpSubmitForm('changePage', ''); return false;">${loop.index + 1}</a>
                        </c:otherwise>
                    </c:choose>

                </c:forEach>

                <c:if test="${remotePublication.executionsPage <= ((remotePublication.executionsCount - 1) / remotePublication.executionsPageSize -1)}">
                    <a href="#" onclick="$('#rpPage').val(${remotePublication.executionsPage + 1});rpSubmitForm('changePage', ''); return false;"><fmt:message key="label.remotepublish.history.next"/></a>
                </c:if>
            </c:if>
        </div>
    </div>

