<%@ page import="org.jahia.modules.remotepublish.RemotePublishUtils" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>

<template:addResources type="javascript" resources="jquery.min.js,jquery-ui.min.js,admin-bootstrap.js,jquery.tablesorter.js,jquery.blockUI.js,workInProgress.js,bootbox.min.js"/>
<template:addResources type="css" resources="admin-bootstrap.css"/>
<template:addResources type="css" resources="jquery-ui.smoothness.css,jquery-ui.smoothness-jahia.css,tablecloth.css"/>

<c:set value="<%= RemotePublishUtils.PERM_REMOTE_PUBLICATION_ADMIN_ACTIONS%>" var="PERM_REMOTE_PUBLICATION_ADMIN_ACTIONS"/>
<c:set value="${jcr:hasPermission(renderContext.mainResource.node, PERM_REMOTE_PUBLICATION_ADMIN_ACTIONS)}" var="hasRemotePublicationAdminPermission"/>

<h2><fmt:message key="label.remotepublish.title"/></h2>


    <fmt:message var="i18nWaiting" key="label.workInProgressTitle"/><c:set var="i18nWaitingJs" value="${functions:escapeJavaScript(i18nWaiting)}"/>
    <fmt:message var="i18nExecute" key="label.executeRemotePublication"/><c:set var="i18nExecuteJs" value="${functions:escapeJavaScript(i18nExecute)}"/>
    <fmt:message var="i18nExecuteConfirm" key="label.remotepublish.execute.confirm"/><c:set var="i18nExecuteConfirmJs" value="${functions:escapeJavaScript(i18nExecuteConfirm)}"/>
    <fmt:message var="i18nEdit" key="label.edit"/>
    <fmt:message var="i18nHistory" key="label.remotepublish.history"/>
    <fmt:message var="i18nAdvanced" key="label.remotepublish.advanced"/>
    <fmt:message var="i18nDelete" key="label.delete"/><c:set var="i18nDeleteJs" value="${functions:escapeJavaScript(i18nDelete)}"/>
    <fmt:message var="i18nDeleteConfirm" key="label.remotepublish.delete.confirm"/>
    <fmt:message var="i18nCancel" key="label.cancel"/><c:set var="i18nCancelJs" value="${functions:escapeJavaScript(i18nCancel)}"/>
    <c:set var="totalCount" value="${fn:length(remotePublications)}"/>

    <template:addResources type="inlinejavascript">
        <script type="text/javascript">

            function rpSubmitForm(act, rpId) {
                $('#rpAction').val(act);
                $('#rpId').val(rpId);
                $('#rpForm').submit();
            }

            <c:if test="${totalCount > 0}">

                function rpConfirmExecute(rpId, rpName, rpUrl, act, label, message) {
                    bootbox.confirm({
                        title: label + ': ' + rpName,
                        message: message + ': ' + rpUrl,
                        buttons: {
                            cancel: {
                                label: '${i18nCancelJs}'
                            },
                            confirm: {
                                label: label,
                                className: 'btn-warning btn-primary'
                            }
                        },
                        callback: function (result) {
                            if (result) {
                                workInProgress('${i18nWaitingJs}');
                                rpSubmitForm(act, rpId);
                            }
                        }
                    });
                }

                function rpConfirmRemove(rpId, rpName, rpUrl) {
                    bootbox.confirm({
                        title: '${i18nDeleteJs}: ' + rpName,
                        message: '${functions:escapeJavaScript(i18nDeleteConfirm)}: ' + rpUrl,
                        buttons: {
                            cancel: {
                                label: '${i18nCancelJs}'
                            },
                            confirm: {
                                label: '${i18nDeleteJs}',
                                className: 'btn-danger btn-primary'
                            }
                        },
                        callback: function (result) {
                            if (result) {
                                workInProgress('${i18nWaitingJs}');
                                rpSubmitForm('delete', rpId);
                            }
                        }
                    });
                }

                $(document).ready(function () {
                    $("#tableRemotePublications").tablesorter({
                        sortList: [[0,0]],
                        headers: { 4: { sorter: false} }
                    });
                });

            </c:if>

        </script>
    </template:addResources>

    <div>
        <div>
            <form action="${flowExecutionUrl}" method="post" style="display: inline;" id="rpForm">
                <input type="hidden" name="rpId" id="rpId" />
                <input type="hidden" id="rpAction" name="_eventId" value="" />

                <c:if test='${hasRemotePublicationAdminPermission}'>
                    <button class="btn" type="submit" name="mybutton" onclick="rpSubmitForm('create', ''); return false;">
                        <i class="icon-plus"></i>
                        &nbsp;<fmt:message key="label.createRemotePublication"/>
                    </button>
                </c:if>
            </form>
        </div>
        <c:if test="${not empty flowRequestContext.messageContext.allMessages}">
            <div>
                <c:forEach items="${flowRequestContext.messageContext.allMessages}" var="message">
                    <c:if test="${message.severity eq 'INFO'}">
                        <div class="alert alert-success">
                            <button type="button" class="close" data-dismiss="alert">&times;</button>
                                ${fn:escapeXml(message.text)}
                        </div>
                    </c:if>
                    <c:if test="${message.severity eq 'ERROR'}">
                        <div class="alert alert-error">
                            <button type="button" class="close" data-dismiss="alert">&times;</button>
                                ${fn:escapeXml(message.text)}
                        </div>
                    </c:if>
                </c:forEach>
            </div>
        </c:if>
        <div>
            <table class="table table-bordered table-striped table-hover" id="tableRemotePublications">
                <thead>
                    <tr>
                        <th>
                            <fmt:message key="label.name"/>
                        </th>
                        <th>
                            <fmt:message key="label.remotepublish.distantUrl"/>
                        </th>
                        <th>
                            <fmt:message key="label.remotepublish.lastExecution"/>
                        </th>
                        <th>
                            <fmt:message key="label.remotepublish.nextExecution"/>
                        </th>
                        <th>
                            <fmt:message key="label.remotepublish.schedule"/>
                        </th>
                        <th>
                            <fmt:message key="label.actions"/>
                        </th>
                    </tr>
                </thead>
                <tbody>
                    <c:choose>
                        <c:when test="${totalCount > 0}">
                            <c:forEach items="${remotePublications}" var="remotePublication">
                                <c:set var="fullUrl" value="${fn:escapeXml(remotePublication.remoteUrl)}${fn:escapeXml(remotePublication.remotePath)}"/>
                                <tr>
                                    <td>
                                        ${fn:escapeXml(remotePublication.name)}
                                    </td>
                                    <td>
                                        ${fullUrl}
                                    </td>
                                    <td>
                                        ${fn:escapeXml(remotePublication.lastExecutionFormatted)}
                                        <c:if test="${remotePublication.lastExecutionResult eq 'failure'}">
                                            <span class="badge badge-important"><fmt:message key="label.remotepublish.failure"/></span>
                                        </c:if>
                                        <c:if test="${remotePublication.lastExecutionResult eq 'success'}">
                                            <span class="badge badge-success"><fmt:message key="label.remotepublish.success"/></span>
                                        </c:if>
                                    </td>
                                    <td>
                                        ${fn:escapeXml(remotePublication.nextExecutionFormatted)}
                                    </td>
                                    <td>
                                        <c:choose>
                                            <c:when test="${not empty remotePublication.scheduleDescription}"><span title="${fn:escapeXml(remotePublication.schedule)}">${fn:escapeXml(remotePublication.scheduleDescription)}</span></c:when>
                                            <c:otherwise>${fn:escapeXml(remotePublication.schedule)}</c:otherwise>
                                        </c:choose>
                                    </td>
                                    <td>
                                        <a style="margin-bottom:0;" class="btn btn-small" title="${fn:escapeXml(i18nExecute)}" href="#execute" onclick="rpConfirmExecute('${remotePublication.id}', '${fn:escapeXml(remotePublication.name)}', '${fullUrl}', 'execute', '${i18nExecuteJs}', '${i18nExecuteConfirmJs}'); return false;">
                                            <i class="icon-play"></i>
                                        </a>
                                        <a style="margin-bottom:0;" class="btn btn-small" title="${fn:escapeXml(i18nHistory)}" href="#history" onclick="rpSubmitForm('history', '${remotePublication.id}'); return false;">
                                            <i class="icon-list"></i>
                                        </a>
                                        <c:if test='${hasRemotePublicationAdminPermission}'>
                                            <a style="margin-bottom:0;" class="btn btn-small" title="${fn:escapeXml(i18nEdit)}" href="#edit" onclick="rpSubmitForm('edit', '${remotePublication.id}'); return false;">
                                                <i class="icon-edit"></i>
                                            </a>
                                            <a style="margin-bottom:0;" class="btn btn-small" title="${fn:escapeXml(i18nAdvanced)}" href="#advanced" onclick="rpSubmitForm('advanced', '${remotePublication.id}'); return false;">
                                                <i class="icon-cog"></i>
                                            </a>
                                            <a style="margin-bottom:0;" class="btn btn-danger btn-small" title="${fn:escapeXml(i18nDelete)}" href="#delete" onclick="rpConfirmRemove('${remotePublication.id}', '${fn:escapeXml(remotePublication.name)}', '${fullUrl}'); return false;">
                                                <i class="icon-remove icon-white"></i>
                                            </a>
                                        </c:if>
                                    </td>
                                </tr>
                            </c:forEach>
                        </c:when>
                        <c:otherwise>
                            <tr>
                                <td colspan="6"><fmt:message key="label.noItemFound"/></td>
                            </tr>
                        </c:otherwise>
                    </c:choose>
                </tbody>
            </table>
        </div>
    </div>

